﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace Ethernet_data
{
    public partial class frmmain : Form
    {
        private const string scanreader = "检测读卡机";
        private const string scanreader_ok = "成功检测到";
        private const string scanreader_fail = "请检查\n\n1、是否已连接 DL9230 Reader \n\n2、如果已经连接，请连接在路由器或交换机这类设备上\n\n3、是否被系统防火墙禁止";
        private const string ip_fail ="网段不同或地址冲突，正在设置";
        private const string set_ok = "设置DL9230 IP 成功";
        private const string set_fail = "设置DL9230 IP 失败";
        private const string start_read = "开始读Tag";
        private const string stop_read = "停止读Tag";

        private UdpClient UDP;
        private UdpClient UDP_send;
        private IPEndPoint iep;
        private bool Closeing = false;
        private bool  resing=false ;
        private byte[] receive_data = new byte[1];
        private string[] ComputerIP = new string[3];

        private RFIDLib.TcpReader_5 tcp_reader = new RFIDLib.TcpReader_5();

        public frmmain()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
        }
        private bool read_message(byte[] data)
        {
            try
            {
                iep = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 65533);
                UDP_send = new UdpClient();

                UDP_send.Send(data, data.Length, iep);//发送数据
                UDP_send.Close();

                UDP = new UdpClient(65534);
                getreaderip.Enabled = false;
                bool result=listen();
                return result;
            }
            catch (Exception err)
            {
                MessageBox.Show(err.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }
        private bool listen()//监听
        {
            try
            {
                int delaytime = 0;
                while (true)
                {
                    Thread.Sleep(100);
                    if (delaytime++ > 20)
                    {
                        return false;
                    }

                    while (Closeing)
                    {
                        Application.DoEvents();
                    }
                    if (UDP != null)
                    {
                        if (UDP.Available > 0)
                        {
                            delaytime = 0;
                            resing = true;
                            receive_data = UDP.Receive(ref iep);//返回接受的数据 Encoding.UTF8.GetString
                            resing = false;
                            if (receive_data.Length != 208) continue;
                            if (receive_data[207] != 13) continue;

                            if (receive_data[1] == 0x10 && receive_data[2] == 0x04)      //获取设备应答
                            {
                                reader.Ip_Address.MAC = receive_data[72] + "-" + receive_data[73] + "-" + receive_data[74] + "-" + receive_data[75] + "-" + receive_data[76] + "-" + receive_data[77];
                                reader.Ip_Address.IP = receive_data[78] + "." + receive_data[79] + "." + receive_data[80] + "." + receive_data[81];
                                reader.Ip_Address.SubnetMask = receive_data[82] + "." + receive_data[83] + "." + receive_data[84] + "." + receive_data[85];
                                reader.Ip_Address.Gateway = receive_data[86] + "." + receive_data[87] + "." + receive_data[88] + "." + receive_data[89];
                                byte[] name = new byte[21];
                                Array.Copy(receive_data, 90, name, 0, 21);
                                reader.Ip_Address.name = Encoding.Default.GetString(name);

                                reader_name.Text = reader.Ip_Address.name;
                                reader_ip.Text = reader.Ip_Address.IP;
                                reader_SubnetMask.Text = reader.Ip_Address.SubnetMask;
                                reader_Gateway.Text = reader.Ip_Address.Gateway;
                                reader_mac.Text = receive_data[72].ToString("X2") + "-" + receive_data[73].ToString("X2") + "-" + receive_data[74].ToString("X2") + "-" + receive_data[75].ToString("X2") + "-" + receive_data[76].ToString("X2") + "-" + receive_data[77].ToString("X2");
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x06)      //设置设备IP地址应答
                            {
                                if (receive_data[77] > 0)
                                {
                                    MessageBox.Show("设置IP地址失败    ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x1F)      //设置设备工作模式应答
                            {
                                if (receive_data[119] == 0)
                                {
                                    MessageBox.Show("设置设备工作模式失败    ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }

                        }
                    }
                    Application.DoEvents();
                }
            }
            finally
            {
                if (UDP != null) UDP.Close();
                getreaderip.Enabled = true;
            }
        }
//***************************************************************************************************************
        private void Form3_Load(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            dataGridView1.Columns[2].DefaultCellStyle.ForeColor = Color.Blue;
        }
        private void frmmain_Shown(object sender, EventArgs e)
        {
            getreaderip_Click(null, null);
        }
        private void frmmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (resing)
            {
                Application.DoEvents();
            }
            Closeing = true;
            tcp_reader.Stop();
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            List<RFIDLib.TAGDATA> listTag = tcp_reader.GetTagData();
            if (listTag.Count > 0)
            {
                string[] str1 = new string[5];
                for (int i = 0; i < listTag.Count; i++)
                {
                    str1[0] = (dataGridView1.RowCount + 1).ToString();
                    str1[1] = listTag[i].strReaderIP;
                    str1[2] = listTag[i].tagID.ToString();
                    str1[3] = listTag[i].time.ToLongTimeString();
                    str1[4] = "1";
                    bool findok = false;
                    for (int row = 1; row < dataGridView1.RowCount; row++)
                    {
                        if (listTag[i].tagID.ToString () == dataGridView1[2, row].Value.ToString())
                        {
                            dataGridView1[3, row].Value = str1[3];
                            dataGridView1[4, row].Value = (int.Parse(dataGridView1[4, row].Value.ToString()) + 1).ToString();
                            //dataGridView1[4, row].Selected=true;
                            findok = true;
                            break;
                        }

                    }
                    if (!findok)
                    {
                        dataGridView1.Rows.Add(str1);
                        dataGridView1.FirstDisplayedScrollingRowIndex = dataGridView1.RowCount - 1;
                    }
                    label7.Text = dataGridView1.RowCount.ToString();
                }
            }
        }

        private void Clearbtn_Click(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            label7.Text = "0";
            
        }

        private void getTagbtn_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
            {
                tcp_reader.Start(ComputerIP[0]+","+"10000");
                timer1.Start();
                addinfo(start_read, false);
            }
            else
            {
                timer1.Stop();
                tcp_reader.Stop();
                addinfo(stop_read, false);
            }
            getTagbtn.Text = string.IsNullOrEmpty(getTagbtn.Tag.ToString()) ? "Stop" : "Read Tag";
            getTagbtn.Tag = string.IsNullOrEmpty(getTagbtn.Tag.ToString()) ? "1" : "";
        }

        private void getreaderip_Click(object sender, EventArgs e)
        {
            reader_name.Text = "";
            reader_ip.Text = "";
            reader_SubnetMask.Text = "";
            reader_Gateway.Text = "";
            reader_mac.Text = "";
            reader.Ip_Address.IP = null;
            int docount = 0;
            bool result=false ;
            byte[] data = reader.GetReader_list();
            addinfo(scanreader,false);
            while (docount++ < 2)
            { 
                 result=read_message(data);
                if(result) break ;
            }
            if (result== false)
            {
                addinfo(scanreader_fail, true);
                MessageBox.Show(scanreader_fail, "没有找到DL9230 Reader", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
            {
                addinfo(scanreader_ok, false);

                if (Class3.getNetwork(ref ComputerIP)) //取本机IP 子网掩码 网关
                {
                    string[] tmp1 = reader.Ip_Address.IP.Split('.');
                    string[] localtion = ComputerIP[0].Split('.');

                    if (reader.Ip_Address.SubnetMask != ComputerIP[1] || reader.Ip_Address.Gateway != ComputerIP[2] || tmp1[0] != localtion[0] || tmp1[1] != localtion[1] || tmp1[2] != localtion[2] || reader.Ip_Address.IP == ComputerIP[0]) //网段不同或掩码不同或网关不同
                    {
                        addinfo(ip_fail, true);

                        string newip = Class3.ScanTarget(localtion[0] + "." + localtion[1] + "." + localtion[2]); //获取局域网一个不空闲IP
                        if (string.IsNullOrEmpty(newip)) return ;

                        data = reader.SETReader(newip, ComputerIP[1], ComputerIP[2], reader.Ip_Address.MAC); //设置reader IP
                        if (read_message(data))
                        {
                            reader_ip.Text = newip;
                            reader_SubnetMask.Text = ComputerIP[1];
                            reader_Gateway.Text = ComputerIP[2];
                            addinfo(set_ok, false);
                        }
                        else
                        {
                            addinfo(set_fail, true);
                        }
                    }
                    data = reader.Set_WorkMode(ComputerIP[0],reader.Ip_Address.MAC); //设置工作模式
                    if (!read_message(data))
                    {
                        return ;
                    }
                }

                getTagbtn.Enabled = true;
                getTagbtn_Click(null, null);
            }
        }
        private void addinfo(string infoname,bool iserror)
        {
            string[] info = new string[2];
            info[0]=(dataGridView2.RowCount + 1).ToString ();
            info[1]=DateTime.Now.ToLongTimeString() + "  " + infoname;
            dataGridView2.Rows.Add(info);
            dataGridView2.Rows[dataGridView2.RowCount - 1].Selected = true;
            if(iserror) dataGridView2.SelectedRows[0].DefaultCellStyle.ForeColor=Color.Red;
            dataGridView2.FirstDisplayedScrollingRowIndex = dataGridView2.RowCount - 1;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView2.RowCount = 0;
        }


      /*  private void button3_Click(object sender, EventArgs e)
        {
            byte[] data = reader.Set_destinationIP();
            read_message(data);
        }*/
    }
}